import java.io.IOException;
import java.util.Scanner;

public class PersonTest {
	static Scanner input = new Scanner(System.in);
	
	static Person setPersonByUserInput() {
		System.out.print("Please enter the name and age: ");
		String n = input.next();
		int a = input.nextInt();
		return new Person(n, a);
	}
	
	static Person[] setPersons(int num) {
		Person[] personArray = new Person[num];
		for (int i=0; i<personArray.length; i++) {
			/*System.out.print("Please enter the name and age: ");
			String n = input.next();
			int a = input.nextInt();
			personArray[i] = new Person(n, a);*/
			personArray[i] = setPersonByUserInput();
		}
		return personArray;
	}
	
	public static boolean getUserInputExitKey() {
		System.out.println("Please enter key to continue or the 'q' key to exit.");
		try {
			if ((char)System.in.read() == 'q') 
				return true;
		}
		catch (IOException e) {
			System.out.println("Error user key reading");
		}
		return false;
	}
	
	public static void main(String[] args) {
		// using default constructor
		/*Person p = new Person();
		p.print();
		System.out.println("p: " + p.toString());
		// using constructor
		Person p2 = new Person("TEST", 1000);
		p2.print();
		// using setter/getter
		p2.setName("Hello");
		p2.setAge(30);
		p2.print();
		System.out.println("p2 name=" + p2.getName() + " age=" + p2.getAge());
		*/
		// using Array
		/*Person[] personArray = new Person[3];
		for (int i=0; i<personArray.length; i++) {
			System.out.print("Please enter the name and age: ");
			String n = input.next();
			int a = input.nextInt();
			personArray[i] = new Person(n, a);
		}*/
		/*Person[] personArray = setPersons(2);
		for (Person per : personArray) {
			per.print();
		}*/
		
		System.out.println("When we share person~~~");
		Person[] pArray = new Person[3];
		Person person = new Person();
		for (int i=0; i<3; i++) {
			System.out.print("Please enter the name and age: ");
			person.setName(input.next());
			person.setAge(input.nextInt());
			pArray[i] = person;
		}
		for (Person per : pArray) {
			per.print();
		}
		
		System.out.println("Hence we need to create a new person~~~");
		Person[] pArray2 = new Person[3];
		for (int i=0; i<3; i++) {
			Person person2 = new Person();
			System.out.print("Please enter the name and age: ");
			person2.setName(input.next());
			person2.setAge(input.nextInt());
			pArray2[i] = person2;
		}
		for (Person per : pArray2) {
			per.print();
		}

		System.out.println("But if you use static member variable and method, the same problem you will see~~~");
		Person2[] pArray3 = new Person2[3];
		for (int i=0; i<3; i++) {
			Person2 person2 = new Person2();
			System.out.print("Please enter the name and age: ");
			person2.setName(input.next());
			person2.setAge(input.nextInt());
			pArray3[i] = person2;
		}
		for (Person2 per : pArray3) {
			per.print();
		}

		System.out.println("So, you have the class having the static member only, please use private constructor!!!!!");
		Person3[] pArray4 = new Person3[3];
		for (int i=0; i<3; i++) {
			//Person3 person3 = new Person3(); // error Person3() has private access in Person3
			System.out.print("Please enter the name and age: ");
			Person3.setName(input.next());
			Person3.setAge(input.nextInt());
			//pArray4[i] = person3; // error person3 ü   Ƿ 
		}
		Person3.print();

		Person[] personArray2 = new Person[3];
		int index = 0;
		char c = ' ';
		do {
			if (index >= personArray2.length) break;
			personArray2[index++] = setPersonByUserInput();
			System.out.println("Please enter any key to continue or the 'q' key to exit.");
			try {
				c = (char)System.in.read();		
			}
			catch (IOException e) {
				System.out.println("Error user key reading");
			}
		} while(c != 'q');
		for (Person per2 : personArray2) {
			if (per2 != null) per2.print();
		}
		
		Person[] personArray3 = new Person[3];
		int index3 = 0;
		do {
			if (index >= personArray3.length) break;
			personArray3[index3++] = setPersonByUserInput();
		} while(!getUserInputExitKey());
		
		for (Person per3 : personArray3) {
			if (per3 != null) per3.print();
		}
		
		System.out.println("done...");
	}

}
